CREATE TABLE `grouplist_config` (
  `name` varchar(255) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`name`)
) TYPE=MyISAM;

CREATE TABLE `grouplist_servers` (
  `id` int(11) NOT NULL auto_increment,
  `shortname` varchar(32) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

CREATE TABLE `grouplist_groups` (
  `server` int(11) NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `count` int(11) NOT NULL default '0',
  `category` int(11) NOT NULL default '0',
  PRIMARY KEY  (`server`,`name`),
  KEY `name` (`name`)
) TYPE=MyISAM;

-- "transaction" tables

CREATE TABLE `grouplist_groups_temp` (
  `server` int(11) NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `count` int(11) NOT NULL default '0',
  `category` int(11) NOT NULL default '0',
  PRIMARY KEY  (`server`,`name`),
  KEY `name` (`name`)
) TYPE=MyISAM;

CREATE TABLE `grouplist_hierarchies_temp` (
`name` VARCHAR( 255 ) BINARY NOT NULL ,
`servers` VARCHAR( 255 ) NOT NULL ,
`hierarchy` VARCHAR( 32 ) BINARY NOT NULL ,
PRIMARY KEY ( `name` ) 
);

-- cache tables

CREATE TABLE `grouplist_hierarchies` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;


CREATE TABLE `grouplist_categories` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `hierarchy` int(11) NOT NULL default '0',
  `groupcount` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

CREATE TABLE `grouplist_cat_server` (
  `category` int(11) NOT NULL default '0',
  `server` int(11) NOT NULL default '0',
  `hierarchy` int(11) NOT NULL default '0',
  `count` int(11) NOT NULL default '0',
  PRIMARY KEY  (`category`,`server`),
  KEY `hierarchy` (`hierarchy`)
) TYPE=MyISAM;

CREATE TABLE `grouplist_pagecache` (
  `id` int(11) NOT NULL,
  `page` mediumtext NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- initial data

INSERT INTO `grouplist_config` VALUES ('locked', '0');
INSERT INTO `grouplist_config` VALUES ('nntp_user', 'onnoaccount');
INSERT INTO `grouplist_config` VALUES ('nntp_pass', 'onnopass');
INSERT INTO `grouplist_config` VALUES ('lastupdate', '0');
INSERT INTO `grouplist_config` VALUES ('admin', 'onnogrouplist');

INSERT INTO `grouplist_servers` VALUES (2, 'news1', 'news1.open-news-network.org');
INSERT INTO `grouplist_servers` VALUES (3, 'news2', 'news2.open-news-network.org');
INSERT INTO `grouplist_servers` VALUES (5, 'news5', 'news4.open-news-network.org');
INSERT INTO `grouplist_servers` VALUES (6, 'news6', 'news6.open-news-network.org');
