<?php
// (c) 2006 Michael Schierl
// #include <gpl.txt>

function microtime_float()
{
   list($usec, $sec) = explode(" ", microtime());
   return ((float)$usec + (float)$sec);
}

$time_start = microtime_float();
error_reporting(E_ALL);
define('WAS_REQUIRED', true);
require("include.php");
define('HEADERINDEX', 4);
$pageTitle="Gruppenliste";
cache_start(2);
require("../globalheader.php");
?>
<h1>Interaktive Gruppenliste des OpenNewsNetworks</h1>

<?=last_update()?>

<h2>Statistiken</h2>

<p><i>&bdquo;Traue keiner Statistik, die du nicht selber geflscht hast&ldquo;</i> -- Winston Churchill (1874-1965)</p>

<table border="1">
<?
server_header("Gesamt");

$sql = "SELECT server, count(DISTINCT hierarchy) FROM grouplist_cat_server " .
	"GROUP BY server ORDER by server";
$result = mysql_query($sql, $dbconn);
if (!$result) {
     die("SQL error query hierarchies: " . mysql_error());
}

echo '<tr><td><b>Hierarchien auf diesem Server</td>';
while ($row = mysql_fetch_row($result)) {
	echo '<td><b>' . $row[0] .'</b></td>';
}

$sql = "SELECT count(*) FROM grouplist_hierarchies";
$result = mysql_query($sql, $dbconn);
if (!$result) {
     die("SQL error count hierarchies: " . mysql_error());
}
if ($row = mysql_fetch_row($result)) {
	echo '<td><b>' . $row[0] . '</b></td></tr>' . "\n";
} else {
	die ("SQL error count hierarchies: " . mysql_error());
}

define('S_ARTICLES', 0);
define('S_GROUPS', 1);
define('S_EMPTY_GROUPS', 2);
define('S_NOT_GROUPS', 3);
define('S_GR_1', 4);
define('S_GR_1_EMPTY', 5);
define('S_GR_2', 6);
define('S_GR_2_LEMPTY', 7);
define('S_GR_2_GEMPTY', 8);
define('S_GR_2_SYNC', 9);
define('S_GR_2_MAX', 10);
define('S_GR_2_MIN', 11);

function makerecord($pf, $sf, $title, $indiv, $sum) {
	global $servers;
	$record = array($pf, $sf, $title, $sum);
	for($i=0; $i<count($servers); $i++) {
		$record[] = $indiv;
	}
	return $record;
}

$stats = array();
$stats[S_ARTICLES] = makerecord('<b>', '</b>', "Artikel auf diesem Server", 0, 0);
$stats[S_GROUPS] = makerecord('<b>', '</b>', "Gruppen auf diesem Server", 0, 0);
$stats[S_EMPTY_GROUPS] = makerecord('', '', "Leere Gruppen", 0, 0);
$stats[S_NOT_GROUPS] = makerecord('', '', "Gruppen <i>nicht</i> auf diesem Server", 0, 0);
$stats[S_GR_1] = makerecord('<b>', '</b>', "Gruppen nur auf <i>einem</i> Server", 0, 0);
$stats[S_GR_1_EMPTY] = makerecord('', '', "Davon leere Gruppen", 0, 0);
$stats[S_GR_2] = makerecord('<b>', '</b>', "Gruppen auf <i>mehreren</i> Servern", 0, 0);
$stats[S_GR_2_LEMPTY] = makerecord('', '', "Davon <i>nur hier</i> leere Gruppen", 0, 'N/A');
$stats[S_GR_2_GEMPTY] = makerecord('', '', "Davon <i>berall</i> leere Gruppen", 0, 0);
$stats[S_GR_2_SYNC] = makerecord('', '', "Gruppen mit berall gleich vielen Artikeln", 0, 0);
$stats[S_GR_2_MAX] = makerecord('', '', "Gruppen mit lngster Haltezeit", 0, "N/A");
$stats[S_GR_2_MIN] = makerecord('', '', "Gruppen mit krzester Haltezeit", 0, "N/A");

$where = "";
$sql = "SELECT g.name, g.server, g.count
         FROM grouplist_groups g 
         ORDER BY g.name";
$result = mysql_query($sql, $dbconn);
if (!$result) {
     die("SQL error query groups: " . mysql_error());
}

$lastgroup = null;
$groupdata = null;

function parsegroup ($lastgroup, $groupdata) {
	global $servers, $stats;
	$gd = array();
	$maxcount=0;
	$mincount = 2147483647;
	$where=0;
	foreach($servers as $server) {
		// prepare values
		if (!isset($groupdata[$server])) {
			$gd[] = -1;
		} else {
			$x = $groupdata[$server];
			$gd[]=$x;
			if ($x > $maxcount) 
				$maxcount=$x;
			if ($x < $mincount)
				$mincount=$x;
			$where++;
		}
	}

	$stats[S_ARTICLES][3] += $maxcount;
	$stats[S_GROUPS][3] += 1;
	$stats[S_EMPTY_GROUPS][3] += ($maxcount==0 ? 1 : 0);
	if ($where == 1) {
		$stats[S_GR_1][3] += 1;
		$stats[S_GR_1_EMPTY][3] += ($maxcount == 0 ? 1 : 0);
	} else if ($where > 1) {
		$stats[S_GR_2][3] += 1;
		$stats[S_GR_2_GEMPTY][3] += ($maxcount == 0 ? 1 : 0);
		$stats[S_GR_2_SYNC][3] += ( $maxcount != 0 && $mincount == $maxcount ? 1 : 0);
	}
	for($i = 0; $i < count($servers); $i++) {
		$c = $gd[$i];
		// fill values
		if ($c == -1) {
			$stats[S_NOT_GROUPS][4+$i] += 1;
		} else {
			$stats[S_ARTICLES][4+$i] += $c;
			$stats[S_GROUPS][4+$i] += 1;
			$stats[S_EMPTY_GROUPS][4+$i] += ($c == 0 ? 1 : 0);
			if ($where == 1) {
				$stats[S_GR_1][4+$i] += 1;
				$stats[S_GR_1_EMPTY][4+$i] += ($c == 0 ? 1 : 0);
			} else if ($where > 1) {
				$stats[S_GR_2][4+$i] += 1;
				$stats[S_GR_2_LEMPTY][4+$i] += ($c == 0 && $maxcount != 0 ? 1 : 0);
				if ($maxcount == 0) {				
					$stats[S_GR_2_GEMPTY][4+$i] += 1;
				} else if ($maxcount == $mincount) {
					$stats[S_GR_2_SYNC][4+$i] += 1;
				} else {
					$stats[S_GR_2_MAX][4+$i] += ($c == $maxcount ? 1 : 0);
					$stats[S_GR_2_MIN][4+$i] += ($c == $mincount ? 1 : 0);
				}
			}
		}
	}
}

while ($row = mysql_fetch_row($result)) {
	$group = $row[0];
	$server =$row[1];
	$count = $row[2];
	if ($lastgroup != $group) {
		if ($lastgroup != null) {
			parsegroup($lastgroup, $groupdata);
		}
		$lastgroup = $group;
		$groupdata = array();
	}
	$groupdata[$server] = $count;
}
if ($lastgroup != null) {
	parsegroup($lastgroup, $groupdata);
}

$stats[S_ARTICLES][3] = "&gt;=".$stats[S_ARTICLES][3];

foreach($stats as $stat) {
	echo '<tr><td>' . $stat[0].$stat[2].$stat[1]. '</td>';
	for($i=4; $i < count($stat); $i++) {
		echo '<td>' . $stat[0].$stat[$i].$stat[1].'</td>';
	}
	echo '<td>' . $stat[0].$stat[3].$stat[1]. '</td></tr>' . "\n";
}
?>
</table>

<hr>
(c) 2005, 2006 Michael Schierl
<?php 
$time_end=microtime_float();
echo '<br><font size="-2">[Execution time: ' . ($time_end - $time_start) . 's]</font>';
writePageEnd();
cache_finish(2);
?>